package com.ozs.base.service.impl;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.ozs.base.domain.BaseProfessional;
import com.ozs.base.mapper.BaseProfessionalMapper;
import com.ozs.base.service.BaseProfessionalService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;

@Service
public class BaseProfessionalServiceImpl extends ServiceImpl<BaseProfessionalMapper, BaseProfessional> implements BaseProfessionalService {

    @Autowired
    private BaseProfessionalMapper baseProfessionalMapper;

    @Override
    public List<BaseProfessional> selectBaseProfessional(BaseProfessional baseProfessional) {
        List<BaseProfessional> allList = baseProfessionalMapper.selectBaseProfessional(baseProfessional);
        List<BaseProfessional> treeList = buildTree(allList);
//        for (BaseProfessional baseProfessional1 : oneGrade) {
//            if (baseProfessional1.getParentCode().length() == 1) {
//                baseProfessionalVoList.add(findChildren(sysMenu, sysMenuList));
//            }
//        }
        //baseProfessionalMapper.selectListByGradeCode(baseProfessional);


        return allList;
    }

    /**
     * 构建树形结构
     * @return
     */
    public static List<BaseProfessional> buildTree(List<BaseProfessional> allList) {
        //创建集合封装最终数据
        List<BaseProfessional> trees = new ArrayList<>();
        //遍历所有菜单集合
        for (BaseProfessional baseProfessional : allList) {
            //找到递归入口，parentId=0
            if (baseProfessional.getParentCode().length() == 1) {
                trees.add(findChildren(baseProfessional, allList));
            }
        }
        return trees;
    }

    /**
     * 从根节点进行递归查询，查询子节点
     * 判断 编码 =  父级编码是否相同，如果相同是子节点，进行数据封装
     */
    private static BaseProfessional findChildren(BaseProfessional baseProfessional, List<BaseProfessional> allList) {
        //数据初始化
        baseProfessional.setBaseProfessionalList(new ArrayList<BaseProfessional>());
        //遍历递归查找
        for (BaseProfessional it : allList) {
            if (baseProfessional.getProfessionalCode().equals(it.getParentCode())) {
                if (baseProfessional.getBaseProfessionalList() == null) {
                    baseProfessional.setBaseProfessionalList(new ArrayList<>());
                }
                baseProfessional.getBaseProfessionalList().add(findChildren(it, allList));
            }
        }
        return baseProfessional;
    }
}
